
// This code was produced by Maphoon 2008.
// Code of struct token:


#include "token.h"


bool token::iswellformed( ) const
{
   switch( type )
   {
   case tkn__recover:
   case tkn__defaultred:
   case tkn_tAnd:
   case tkn_tAssign:
   case tkn_tBool:
   case tkn_tComma:
   case tkn_tDivision:
   case tkn_tDo:
   case tkn_tDouble:
   case tkn_tElse:
   case tkn_tEqual:
   case tkn_tFalse:
   case tkn_tIf:
   case tkn_tGreater:
   case tkn_tGreaterEqual:
   case tkn_tLeftBrace:
   case tkn_tLeftPar:
   case tkn_tLess:
   case tkn_tLessEqual:
   case tkn_tMinus:
   case tkn_tMultiplication:
   case tkn_tNot:
   case tkn_tNotEqual:
   case tkn_tOr:
   case tkn_tPlus:
   case tkn_tReturn:
   case tkn_tRightBrace:
   case tkn_tRightPar:
   case tkn_tSemicolon:
   case tkn_tTrue:
   case tkn_tVoid:
   case tkn_tWhile:
   case tkn_Start:
   case tkn_LoopStatement:
   case tkn_LoopStatementCondition:
   case tkn_tEof:
   case tkn_tPrint:
      if( tp. size( ) >= 1 ) return false;
      if( tr. size( ) >= 1 ) return false;
      if( trlen. size( ) >= 1 ) return false;
      return true;
   case tkn_tIdentifier:
   case tkn_tNumber:
   case tkn_tString:
   case tkn_ReturnType_FunctionIdentifier:
   case tkn_Type:
      if( tp. size( ) >= 1 ) return false;
      if( tr. size( ) < 1 ) return false;
      if( tr. size( ) >= 2 ) return false;
      if( trlen. size( ) >= 1 ) return false;
      return true;
   case tkn_TranslationUnits:
      if( tp. size( ) >= 1 ) return false;
      if( tr. size( ) < 1 ) return false;
      if( trlen. size( ) < 1 ) return false;
      return true;
   case tkn_FunctionDefinition:
   case tkn_FormalArguments:
   case tkn_FunctionBody:
   case tkn_LocalDefinitions:
   case tkn_InstructionsBlock:
   case tkn_Instruction:
   case tkn_Assignment:
   case tkn_ReturnInstruction:
   case tkn_IfElseStatement:
   case tkn_BracedBlock:
      if( tp. size( ) >= 1 ) return false;
      if( tr. size( ) < 1 ) return false;
      if( tr. size( ) >= 2 ) return false;
      if( trlen. size( ) < 1 ) return false;
      if( trlen. size( ) >= 2 ) return false;
      return true;
   case tkn_FunctionCall:
      if( tp. size( ) < 1 ) return false;
      if( tp. size( ) >= 2 ) return false;
      if( tr. size( ) < 2 ) return false;
      if( tr. size( ) >= 3 ) return false;
      if( trlen. size( ) < 1 ) return false;
      if( trlen. size( ) >= 2 ) return false;
      return true;
   case tkn_FunctionArguments:
      if( tp. size( ) < 1 ) return false;
      if( tp. size( ) >= 2 ) return false;
      if( tr. size( ) < 1 ) return false;
      if( tr. size( ) >= 2 ) return false;
      if( trlen. size( ) < 2 ) return false;
      if( trlen. size( ) >= 3 ) return false;
      return true;
   case tkn_ArithmeticalExpression:
   case tkn_Addend:
   case tkn_Factor:
   case tkn_IfElseCondition:
   case tkn_LogicalExpression:
   case tkn_Conjuction:
   case tkn_LogicalValue:
   case tkn_Comparison:
      if( tp. size( ) < 1 ) return false;
      if( tp. size( ) >= 2 ) return false;
      if( tr. size( ) < 1 ) return false;
      if( tr. size( ) >= 2 ) return false;
      if( trlen. size( ) < 1 ) return false;
      if( trlen. size( ) >= 2 ) return false;
      return true;
   }
   return false; // Because of unknown type.
}


// If you see an insane error message originating from
// this point, then the most probably reason is that
// one of the attribute types has no print function defined.

std::ostream& operator << ( std::ostream& stream, const token& t )
{
   switch( t. type )
   {
   case tkn__recover:
      stream << "_recover( "; break;
   case tkn__defaultred:
      stream << "_defaultred( "; break;
   case tkn_tAnd:
      stream << "tAnd( "; break;
   case tkn_tAssign:
      stream << "tAssign( "; break;
   case tkn_tBool:
      stream << "tBool( "; break;
   case tkn_tComma:
      stream << "tComma( "; break;
   case tkn_tDivision:
      stream << "tDivision( "; break;
   case tkn_tDo:
      stream << "tDo( "; break;
   case tkn_tDouble:
      stream << "tDouble( "; break;
   case tkn_tElse:
      stream << "tElse( "; break;
   case tkn_tEqual:
      stream << "tEqual( "; break;
   case tkn_tFalse:
      stream << "tFalse( "; break;
   case tkn_tIdentifier:
      stream << "tIdentifier( "; break;
   case tkn_tIf:
      stream << "tIf( "; break;
   case tkn_tGreater:
      stream << "tGreater( "; break;
   case tkn_tGreaterEqual:
      stream << "tGreaterEqual( "; break;
   case tkn_tLeftBrace:
      stream << "tLeftBrace( "; break;
   case tkn_tLeftPar:
      stream << "tLeftPar( "; break;
   case tkn_tLess:
      stream << "tLess( "; break;
   case tkn_tLessEqual:
      stream << "tLessEqual( "; break;
   case tkn_tMinus:
      stream << "tMinus( "; break;
   case tkn_tMultiplication:
      stream << "tMultiplication( "; break;
   case tkn_tNot:
      stream << "tNot( "; break;
   case tkn_tNotEqual:
      stream << "tNotEqual( "; break;
   case tkn_tNumber:
      stream << "tNumber( "; break;
   case tkn_tOr:
      stream << "tOr( "; break;
   case tkn_tPlus:
      stream << "tPlus( "; break;
   case tkn_tReturn:
      stream << "tReturn( "; break;
   case tkn_tRightBrace:
      stream << "tRightBrace( "; break;
   case tkn_tRightPar:
      stream << "tRightPar( "; break;
   case tkn_tSemicolon:
      stream << "tSemicolon( "; break;
   case tkn_tString:
      stream << "tString( "; break;
   case tkn_tTrue:
      stream << "tTrue( "; break;
   case tkn_tVoid:
      stream << "tVoid( "; break;
   case tkn_tWhile:
      stream << "tWhile( "; break;
   case tkn_Start:
      stream << "Start( "; break;
   case tkn_TranslationUnits:
      stream << "TranslationUnits( "; break;
   case tkn_FunctionDefinition:
      stream << "FunctionDefinition( "; break;
   case tkn_ReturnType_FunctionIdentifier:
      stream << "ReturnType_FunctionIdentifier( "; break;
   case tkn_Type:
      stream << "Type( "; break;
   case tkn_FormalArguments:
      stream << "FormalArguments( "; break;
   case tkn_FunctionBody:
      stream << "FunctionBody( "; break;
   case tkn_LocalDefinitions:
      stream << "LocalDefinitions( "; break;
   case tkn_InstructionsBlock:
      stream << "InstructionsBlock( "; break;
   case tkn_Instruction:
      stream << "Instruction( "; break;
   case tkn_Assignment:
      stream << "Assignment( "; break;
   case tkn_FunctionCall:
      stream << "FunctionCall( "; break;
   case tkn_FunctionArguments:
      stream << "FunctionArguments( "; break;
   case tkn_ArithmeticalExpression:
      stream << "ArithmeticalExpression( "; break;
   case tkn_Addend:
      stream << "Addend( "; break;
   case tkn_Factor:
      stream << "Factor( "; break;
   case tkn_ReturnInstruction:
      stream << "ReturnInstruction( "; break;
   case tkn_IfElseStatement:
      stream << "IfElseStatement( "; break;
   case tkn_IfElseCondition:
      stream << "IfElseCondition( "; break;
   case tkn_LogicalExpression:
      stream << "LogicalExpression( "; break;
   case tkn_Conjuction:
      stream << "Conjuction( "; break;
   case tkn_LogicalValue:
      stream << "LogicalValue( "; break;
   case tkn_Comparison:
      stream << "Comparison( "; break;
   case tkn_LoopStatement:
      stream << "LoopStatement( "; break;
   case tkn_LoopStatementCondition:
      stream << "LoopStatementCondition( "; break;
   case tkn_BracedBlock:
      stream << "BracedBlock( "; break;
   case tkn_tEof:
      stream << "tEof( "; break;
   case tkn_tPrint:
      stream << "tPrint( "; break;
   default:
      stream << "UNKNOWNTOKEN( ";
   }

   unsigned int arg = 0;
   unsigned int arginlist;

   arginlist = 0;
   for( std::list< std::string > :: const_iterator
           p = t. tp. begin( );
           p != t. tp. end( );
           ++ p )
   {
      if( arg != 0 && arginlist == 0 ) stream << "; ";
      if( arg != 0 && arginlist != 0 ) stream << ", ";
      stream << *p;
      ++ arg;
      ++ arginlist;
   }

   arginlist = 0;
   for( std::list< std::string > :: const_iterator
           p = t. tr. begin( );
           p != t. tr. end( );
           ++ p )
   {
      if( arg != 0 && arginlist == 0 ) stream << "; ";
      if( arg != 0 && arginlist != 0 ) stream << ", ";
      stream << *p;
      ++ arg;
      ++ arginlist;
   }

   arginlist = 0;
   for( std::list< int > :: const_iterator
           p = t. trlen. begin( );
           p != t. trlen. end( );
           ++ p )
   {
      if( arg != 0 && arginlist == 0 ) stream << "; ";
      if( arg != 0 && arginlist != 0 ) stream << ", ";
      stream << *p;
      ++ arg;
      ++ arginlist;
   }

   stream << " )";
   return stream;
}


